class EquipTriggerVolume extends TriggerVolume placeable;

var() bool bDestroyFlashlight;
var() bool bDestroyHover;
var() bool bDestroyImpact;
var() bool bDestroyEnforcer;
var() bool bDestroyInsta;
var() bool bDestroyAllOtherWeapons;
var() bool bDisableFeignDeath;
var() bool bDestroyAllOtherPickups;

var() bool bEquipWithFlashlight;
var() bool bEquipWithHover;
var() bool bEquipWithImpact;
var() bool bEquipWithEnforcer;
var() bool bEquipWithInsta;
var() bool bEnableFeignDeath;

function int GetE() {
	local bool bTake;
	local bool bGive;
	local int e;
	e = 0;
	if(bDestroyFlashlight) {
		if(!bEquipWithFlashlight) {
			bTake = true;
		}
		e += 1 << 1;
	}
	if(bDestroyHover) {
		if(!bEquipWithHover) {
			bTake = true;
		}
		e += 1 << 2;
	}
	if(bDestroyImpact) {
		if(!bEquipWithImpact) {
			bTake = true;
		}
		e += 1 << 3;
	}
	if(bDestroyEnforcer) {
		if(!bEquipWithEnforcer) {
			bTake = true;
		}
		e += 1 << 4;
	}
	if(bDestroyInsta) {
		if(!bEquipWithInsta) {
			bTake = true;
		}
		e += 1 << 5;
	}
	if(bDestroyAllOtherWeapons) {
		bTake = true;
		e += 1 << 6;
	}
	if(bDisableFeignDeath) {
		bTake = true;
		e += 1 << 7;
	}
	if(bDestroyAllOtherPickups) {
		bTake = true;
		e += 1 << 8;
	}
	if(bTake == true) {
		e += 1 + (1 << 12);
	}
	if(bEquipWithFlashlight) {
		bGive = true;
		e += 1 << 16;
	}
	if(bEquipWithHover) {
		bGive = true;
		e += 1 << 17;
	}
	if(bEquipWithImpact) {
		bGive = true;
		e += 1 << 18;
	}
	if(bEquipWithEnforcer) {
		bGive = true;
		e += 1 << 19;
	}
	if(bEquipWithInsta) {
		bGive = true;
		e += 1 << 20;
	}
	if(bEnableFeignDeath) {
		bGive = true;
		e += 1 << 22;
	}
	if(bGive == true) {
		e += (1 << 15) + (1 << 28);
	}
	return e;
}


event Touch(Actor Other, PrimitiveComponent OtherComp, vector HitLocation,
							vector HitNormal) {
	local Pawn P;
	local BTPawn BTP; // driver of the vehicle, if any
	local BTPlayerController BC;

	P = Pawn(Other);
		// if this is a vehicle, get the driver
	if(P != None) {
		if(bDestroyHover && !bEquipWithHover) {
			if(UTVehicle_Hoverboard(P) != None) {
				UTVehicle_Hoverboard(P).DriverLeave(true);
			}
		}
		if(UTVehicle(P) != None) {
			BTP = BTPawn(UTVehicle(P).Driver);
		} else {
			BTP = BTPawn(P);
		}
	}
	// if player has recently used this equip point, no further actions
	if(BTP != None) {
		BC = BTPlayerController(BTP.Controller);
		if(BC != None) {
			if(BC.LastEquipID == self.Name) {
				return;
			} else {
				BC.LastEquipID = self.Name;
			}
		}
		BTP.Equip(GetE());
	}
	super.Touch(Other, OtherComp, HitLocation, HitNormal);
}

defaultproperties
{

}

